<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  admin_ads_category.php                                   ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	check_admin_security("ads");

 	$t = new VA_Template($settings["admin_templates_dir"]);
 	$t->set_file("main","admin_ads_category.html");

	$t->set_var("admin_ads_category_href", "admin_ads_category.php");
	$t->set_var("admin_select_href",   "admin_select.php");
	$t->set_var("admin_upload_href",   "admin_upload.php");
	$t->set_var("admin_ads_href",      "admin_ads.php");

	$category_id = get_param("category_id");

	$r = new VA_Record($table_prefix . "ads_categories");
	
	$r->add_where("category_id", INTEGER);
	$r->add_textbox("category_order", TEXT, "Category order");
	$r->change_property("category_order", REQUIRED, true);
	$r->add_textbox("total_views", INTEGER);
	$r->change_property("total_views", USE_IN_INSERT, false);
	$r->change_property("total_views", USE_IN_UPDATE, false);
	$r->add_textbox("category_name", TEXT, "Category name");
	$r->change_property("category_name", REQUIRED, true);
	$r->change_property("category_name", MAX_LENGTH, 255);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");

	$allowed_values = array(array("0", "Nobody"), array("1", "All users"), array("2", "Only registered users"));
	$allowed_values = array(array("0", "Nobody"), array("1", "All users"));
	$r->add_radio("allowed_view", INTEGER, $allowed_values, "Allowed view category");
	$r->add_checkbox("allowed_post", INTEGER);
	$r->add_textbox("image_small", TEXT);
	$r->add_textbox("image_large", TEXT);
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);

	$r->add_textbox("parent_category_id", TEXT);
	$r->change_property("parent_category_id", USE_IN_UPDATE, false);
	$r->add_textbox("category_path", TEXT);
	$r->change_property("category_path", USE_IN_UPDATE, false);

	//$r->add_textbox("alias_category_id", TEXT);
	//$r->add_textbox("language_code", TEXT, "Language code");
	$r->add_hidden("total_ads", INTEGER);
	$r->change_property("total_ads", USE_IN_INSERT, true);
	$r->add_hidden("total_subcategories", INTEGER);
	$r->change_property("total_subcategories", USE_IN_INSERT, true);

	$r->get_form_values();

	if(!strlen($r->get_value("parent_category_id"))) $r->set_value("parent_category_id", "0");
	$parent_category_id = $r->get_value("parent_category_id");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "ads_categories", "tree", "Ads");
	$tree->show($parent_category_id);

	$operation = get_param("operation");
	$return_page = "admin_ads.php?category_id=" . $parent_category_id;
	if(strlen($operation))
	{
		$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "ads_categories", "");

		if ($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} else if($operation == "delete" && $r->get_value("category_id")) {
			$categories = "";
			$category_path = $tree->get_path($category_id);
			$sql  = " SELECT category_id FROM " . $table_prefix . "ads_categories ";
			$sql .= " WHERE category_id = " . $db->tosql($category_id, INTEGER);
			$sql .= " OR category_path LIKE '" . $db->tosql($category_path, TEXT, false) . "%'";
			$db->query($sql);
			while ($db->next_record()) {
				$categories[] = $db->f("category_id");
			}

			if(is_array($categories)) {
				for($i = 0; $i < sizeof($categories); $i++) {
					$db->query("DELETE FROM " . $table_prefix . "ads_assigned WHERE category_id = " . $db->tosql($categories[$i], INTEGER));
					$db->query("DELETE FROM " . $table_prefix . "ads_categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
				}
			}
			if ($parent_category_id) {
				$db->query("UPDATE " . $table_prefix . "ads_categories SET total_subcategories = total_subcategories - 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
			}
	
			header("Location: " . $return_page);
			exit;
		} 

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			if(strlen($r->get_value("category_id"))) {
				set_friendly_url();
				$record_updated = $r->update_record();
			}	else {
				set_friendly_url();
				$r->set_value("category_path", $tree->get_path($r->get_value("parent_category_id")));
				$r->set_value("total_ads", 0);
				$r->set_value("total_subcategories", 0);
				$record_updated = $r->insert_record();
				if ($record_updated && $parent_category_id) {
					$db->query("UPDATE " . $table_prefix . "ads_categories SET total_subcategories = total_subcategories + 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
				}
			}
			if ($record_updated) {
				header("Location: " . $return_page);
				exit;
			}
		}
	} else if(strlen($r->get_value("category_id"))) { // edit existing category
		$r->get_db_values();
	} else { // new category - set default values
		$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "ads_categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
		$category_order++;
		$r->set_value("category_order", $category_order);
		$r->set_value("allowed_view", 1);
		$r->set_value("allowed_post", 1);
	}

	$r->set_parameters();

	if(strlen($category_id)) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>