<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_tax_rate.php                                       ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("sales_orders");
	check_admin_security("tax_rates");

	$eol = get_eol();

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_tax_rate.html");

	$t->set_var("admin_tax_rate_href", "admin_tax_rate.php");
	$t->set_var("admin_tax_rates_href", "admin_tax_rates.php");

	$r = new VA_Record($table_prefix . "tax_rates");

	// load data to listbox
	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", "Any State")));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ", array(array("", "--- Select Country ---")));

	$r->add_where("tax_id", INTEGER);
	$r->change_property("tax_id", USE_IN_INSERT, true);

	$r->add_textbox("tax_name", TEXT, "Tax Name");
	$r->change_property("tax_name", REQUIRED, true);
	$r->add_select("state_code", TEXT, $states, "State");
	$r->add_select("country_code", TEXT, $countries, "Country");
	$r->change_property("country_code", REQUIRED, true);

	$r->add_textbox("tax_percent", FLOAT, "Tax Percent");
	$r->change_property("tax_percent", REQUIRED, true);

	$r->get_form_values();

	$tax_rates_items = array();
	$sql  = " SELECT it.item_type_id, it.item_type_name, tri.tax_percent ";
	$sql .= " FROM (" . $table_prefix . "item_types it ";
	$sql .= " LEFT JOIN " . $table_prefix . "tax_rates_items tri ON (it.item_type_id=tri.item_type_id ";
	$sql .= " AND tri.tax_id=" . $db->tosql($r->get_value("tax_id"), INTEGER) . ")) ";
	$db->query($sql);
	while ($db->next_record()) {
		$item_type_id = $db->f("item_type_id");
		$item_type_name = get_translation($db->f("item_type_name"));
		$item_tax_percent = $db->f("tax_percent");
		$tax_rates_items[] = array($item_type_id, $item_type_name, $item_tax_percent);
	}
                                                                  
	$operation = get_param("operation");
	$tax_id = get_param("tax_id");
	$return_page = "admin_tax_rates.php";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $tax_id)
		{
			$r->delete_record();

			$sql = " DELETE FROM " . $table_prefix . "tax_rates_items WHERE tax_id=" . $db->tosql($tax_id, INTEGER);
			$db->query($sql);

			header("Location: " . $return_page);
			exit;
		}

		$r->validate();

		if(!$r->is_empty("country_code")) {
			$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "tax_rates ";
			$sql .= " WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT);
			if ($r->is_empty("state_code")) {
				$sql .= " AND state_code IS NULL ";
			} else {
				$sql .= " AND state_code=" . $db->tosql($r->get_value("state_code"), TEXT);
			}
			$sql .= $r->is_empty("tax_id") ? "" : " AND tax_id<>" . $db->tosql($tax_id, INTEGER);
			if(get_db_value($sql)) {
				$r->errors .= "Tax for <b>" . get_array_value($r->get_value("country_code"), $countries) . "</b>";
				if (!$r->is_empty("state_code")) {
					$r->errors .= " <b>(" . get_array_value($r->get_value("state_code"), $states) . ")</b>";
				}
				$r->errors .= " already exists.";
			}
		}

		for ($i = 0; $i < sizeof($tax_rates_items); $i++) {
			list ($item_type_id, $item_type_name, $item_tax_percent) = $tax_rates_items[$i]; 
			$item_tax_percent = get_param("item_tax_percent_" . $item_type_id);
			$tax_rates_items[$i][2] = $item_tax_percent;
			if ($item_tax_percent && !is_numeric($item_tax_percent)) {
				$error_message = str_replace("{field_name}", $item_type_name, INCORRECT_VALUE_MESSAGE);
				$r->errors .= $error_message . "<br>" . $eol;
			}
		}

		if(!strlen($r->errors))
		{
			if (strlen($r->get_value("tax_id"))) {
				$r->update_record();
			} else {
				$sql = "SELECT MAX(tax_id) FROM " . $table_prefix . "tax_rates ";
				$tax_id = get_db_value($sql);
				$r->set_value("tax_id", ($tax_id + 1));
				$r->insert_record();
			}

			// update item types tax percents
			$sql = " DELETE FROM " . $table_prefix . "tax_rates_items WHERE tax_id=" . $db->tosql($tax_id, INTEGER);
			$db->query($sql);
			for ($i = 0; $i < sizeof($tax_rates_items); $i++) {
				list ($item_type_id, $item_type_name, $item_tax_percent) = $tax_rates_items[$i]; 
				$sql  = " INSERT INTO " . $table_prefix . "tax_rates_items (tax_id, item_type_id, tax_percent) VALUES (";
				$sql .= $db->tosql($r->get_value("tax_id"), INTEGER) . ", ";
				$sql .= $db->tosql($item_type_id, INTEGER) . ", ";
				$sql .= $db->tosql($item_tax_percent, FLOAT) . ") ";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	} else if(strlen($r->get_value("tax_id"))) {
		$r->get_db_values();
	} else { 
		// new item (set default values)
	}


	$r->set_form_parameters();
	for ($i = 0; $i < sizeof($tax_rates_items); $i++) {
		list ($item_type_id, $item_type_name, $item_tax_percent) = $tax_rates_items[$i]; 
		$t->set_var("item_type_id", $item_type_id);
		$t->set_var("item_type_name", $item_type_name);
		$t->set_var("item_tax_percent", $item_tax_percent);
		$t->parse("tax_rates_items", true);
	}
	
	if(strlen($tax_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_tax_rates_href", "admin_tax_rates.php");
	$t->pparse("main");

?>
