<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  block_manuals_list.php                                   ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	function manuals_list($block_name) {
		global $t, $db, $table_prefix, $settings, $datetime_show_format;
		$category_id = get_param("category_id");

		// Global friendly url settings
		$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
		$friendly_extension = get_setting_value($settings, "friendly_extension", "");		
		
		$manual_articles_href = "manuals_articles.php?manual_id=";
		// Set messages variables
		$t->set_var("MANUALS_TITLE", MANUALS_TITLE);
		$t->set_var("NO_MANUALS_MSG", NO_MANUALS_MSG);
		
		$t->set_file("block_body", "block_manuals_list.html");
		$sql = "SELECT * FROM ".$table_prefix."manuals_categories AS mc LEFT JOIN ";
		$sql .= $table_prefix."manuals_list AS ml ON mc.category_id = ml.category_id ";
		$sql .= " WHERE mc.allowed_view = 1 AND ml.allowed_view = 1 ";
		if ($category_id != "") {
			$sql .= " AND mc.category_id = " . $db->tosql($category_id, INTEGER);
		}
		$sql .= " ORDER BY mc.category_order, ml.manual_order";

		$db->query($sql);
		$prev_category_id = 0;
		if ($db->next_record()) {
			do {
				$category_id = $db->f("category_id");
				
				if ($prev_category_id != $category_id) {
					//$prev_category_id = $category_id;
					if ($prev_category_id != 0) {
						$t->parse("categories", true);
						$t->set_var("manuals", "");
					}
				}
				
				$t->set_var("cat_name", $db->f("category_name"));
				$manual_id = $db->f("manual_id");
				// Parse manual
				$t->set_var("manual_title", $db->f("manual_title"));
				$t->set_var("short_description", $db->f("short_description"));
				$friendly_url = $db->f("friendly_url");
				
				if ($friendly_urls && $friendly_url != "") {
					$manual_href = $friendly_url . $friendly_extension;
				} else {
					$manual_href = $manual_articles_href.$manual_id;
				}
				$t->set_var("manual_href", $manual_href);
				$t->parse("manuals", true);
				
				$prev_category_id = $category_id;
			} while ($db->next_record());
			$t->set_var("category_id", $category_id);
			$t->parse("categories", true);
		}
		
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
?>