<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  google_process.php                                       ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * Google Checkout (https://checkout.google.com/) transaction handler by www..com
 */

    function CalcHmacSha1($data) {
    	global $payment_params;
		$key = $payment_params['merchant_key'];
		$blocksize = 64;
		$hashfunc = 'sha1';
		if (strlen($key) > $blocksize) {
			$key = pack('H*', $hashfunc($key));
		}
		$key = str_pad($key, $blocksize, chr(0x00));
		$ipad = str_repeat(chr(0x36), $blocksize);
		$opad = str_repeat(chr(0x5c), $blocksize);
		$hmac = pack(
			'H*', $hashfunc(
				($key^$opad).pack(
					'H*', $hashfunc(
						($key^$ipad).$data
					)
				)
			)
		);
      return $hmac; 
    }

    function payment_variables($order_id){
    	global $db, $table_prefix, $settings;
		$variables = array();
		$variables["site_url"] = $settings["site_url"];
		$variables["order_id"] = $order_id;
		$sql  = " SELECT * FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			// payment information
			$payment_id = $db->f("payment_id");
	
			$variables["user_id"] = $db->f("user_id");
			$variables["total_quantity"] = $db->f("total_quantity");
			// email variables
			$variables["email"] = $db->f("email");
			$delivery_email["delivery_email"] = $db->f("delivery_email");
	
			// shopping variables
			$variables["goods_total"] = $db->f("goods_total");
			$variables["total_discount"] = $db->f("total_discount");
			$variables["total_discount_tax"] = $db->f("total_discount_tax");
			$variables["goods_with_discount"] = $variables["goods_total"] - $variables["total_discount"];
			$variables["shipping_cost"] = $db->f("shipping_cost");
			$variables["tax_percent"] = $db->f("tax_percent");
			$variables["tax_total"] = $db->f("tax_total");
			$variables["tax_name"] = $db->f("tax_name");
			$variables["processing_fee"] = $db->f("processing_fee");
			$variables["order_total"] = $db->f("order_total");
			$variables["order_placed_date"] = $db->f("order_placed_date", DATETIME);
	
			$variables["name"] = $db->f("name");
			$variables["first_name"] = $db->f("first_name");
			$variables["last_name"] = $db->f("last_name");
			$variables["company_name"] = $db->f("company_name");
			$variables["address1"] = $db->f("address1");
			$variables["address2"] = $db->f("address2");
			$variables["city"] = $db->f("city");
			$variables["province"] = $db->f("province");
			$variables["zip"] = $db->f("zip");
			$variables["phone"] = $db->f("phone");
			$variables["daytime_phone"] = $db->f("daytime_phone");
			$variables["evening_phone"] = $db->f("evening_phone");
			$variables["cell_phone"] = $db->f("cell_phone");
			$variables["fax"] = $db->f("fax");
			$variables["state_code"] = $db->f("state_code");
			$variables["country_code"] = $db->f("country_code");

			$shipping_type_desc = $db->f("shipping_type_desc");
			$variables["shipping_type_desc"] = $shipping_type_desc;
			$variables["shipping_tax"] = ($db->f("shipping_taxable"))?$variables["tax_percent"]:0;
			$tax_name = $db->f("tax_name");
			$tax_cost = $db->f("tax_total");

			$currency_code = $db->f("currency_code");
			$currency = get_currency($currency_code);
			$currency_left = $currency["left"];
			$currency_right = $currency["right"];
			$currency_rate = $currency["rate"];
			$currency_code = $currency["code"];
			$currency_value = $currency["value"];

			$variables["shipping_cost_cr"] = round($variables["shipping_cost"] * $currency_rate, 2);
			$variables["shipping_cost_with_tax_cr"] = round(($variables["shipping_cost"]+$variables["shipping_cost"] / 100 * $variables["shipping_tax"]) * $currency_rate, 2);
			$variables["shipping_tax_cr"] = round($variables["shipping_tax"] * $currency_rate, 2);
			$variables["total_discount_with_tax_cr"] = round(($variables["total_discount"]+$variables["total_discount_tax"]) * $currency_rate, 2);
		}
	
		$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
		$variables["country"] = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT));

		$eol = get_eol();

		$items_text = "";
		$variables["items"] = array();
		$sql  = " SELECT * FROM " . $table_prefix . "orders_items ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		while ($db->next_record()) {
			$items = array();
			$item_text = get_translation($db->f("item_name"));
			$items['item_text'] = $item_text;
			$quantity = $db->f("quantity");
			$items['quantity'] = $quantity;
			$price = $db->f("price");
			$items['price'] = round($price * $currency_rate, 2);
			$items['tax'] = ($db->f("tax_free"))?0:$db->f("tax_percent");
			$items['price_with_tax'] = $items['price'] + $items['price'] / 100 * $items['tax'];
			$items['total_tax'] = round($quantity * $items['price'] / 100 * $items['tax'] * $currency_rate, 2);
			$items['total_price_with_tax'] = round($quantity * ($items['price'] + $items['price'] / 100 * $items['tax'])* $currency_rate, 2);
			$item_total = $price * $quantity;
			$item_text .= " " . PROD_QTY_COLUMN . ": " . $quantity . " " . $currency_left . number_format($item_total * $currency_rate, 2) . $currency_right;
			$items_text .= $item_text . $eol;
			$variables["items"][]=$items;

		}

		$items_text .= GOODS_TOTAL_MSG . ": " . $currency_left . number_format($variables["goods_total"] * $currency_rate, 2) . $currency_right . $eol;
		if (strlen($variables["total_discount"] != 0)) {
			$items_text .= TOTAL_DISCOUNT_MSG . ": -" . $currency_left . number_format($variables["total_discount"] * $currency_rate, 2) . $currency_right . $eol;
			$items_text .= GOODS_WITH_DISCOUNT_MSG. ": " . $currency_left . number_format(($variables["goods_with_discount"]) * $currency_rate, 2) . $currency_right . $eol;
		}
		if (strlen($shipping_type_desc)) {
			$items_text .= $shipping_type_desc . ": " . $currency_left . number_format($variables["shipping_cost"] * $currency_rate, 2) . $currency_right . $eol;
 		}
		if (strlen($tax_name)) {
			$tax_cost = round($tax_cost, 2);
			$items_text .= $tax_name . ": " . $currency_left . number_format($tax_cost * $currency_rate, 2) . $currency_right . $eol;
		}
		if ($variables["processing_fee"] != 0) {
			$items_text .= PROCESSING_FEE_MSG . ": " . $currency_left . number_format($variables["processing_fee"] * $currency_rate, 2) . $currency_right;
			$variables["processing_fee_cr"] = number_format($variables["processing_fee"] * $currency_rate, 2);
		}
		$items_text .= CART_TOTAL_MSG . ": " . $currency_left . number_format($variables["order_total"] * $currency_rate, 2) . $currency_right;

		$variables["basket"] = $items_text;
		return $variables;
	}

	function payment_params($order_id){
    	global $db, $table_prefix;
		$sql  = " SELECT * FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$payment_id = $db->f("payment_id");
		}
		if (strlen($payment_id)) {
			$variables = payment_variables($order_id);
			if(!is_array($variables)){
				return;
			}
			$payment_params = array();
			$sql  = " SELECT parameter_name, parameter_source, not_passed ";
			$sql .= " FROM " . $table_prefix . "payment_parameters ";
			$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
			$db->query($sql);
			while ($db->next_record()) {
				$parameter_name = trim($db->f("parameter_name"));
				$parameter_source = trim($db->f("parameter_source"));
				$not_passed = trim($db->f("not_passed"));
				if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
					$parameter_value = $parameter_source;
					for($p = 0; $p < sizeof($matches[1]); $p++) {
						$l_source = strtolower($matches[1][$p]);
						if (isset($variables[$l_source])) {
							$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
						}
					}
				} else if (isset($variables[$parameter_source])) {
					$parameter_value = $variables[$parameter_source];
				} else {
					$parameter_value = $parameter_source;
				}
				$payment_params[$parameter_name] = $parameter_value;
			}
		} else {
			return;
		}
		return $payment_params;
	}

    function set_error($order_id, $error_message){
    	global $db, $table_prefix;
		$sql  = " UPDATE " . $table_prefix . "orders ";
		$sql .= " SET error_message=" . $db->tosql($error_message, TEXT) ;
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER) ;
		$db->query($sql);
	}

	$is_admin_path = true;
	$root_folder_path = "../";

	include_once ($root_folder_path ."includes/common.php");
	include_once ($root_folder_path ."includes/order_items.php");
	include_once ($root_folder_path ."includes/date_functions.php");
    include_once ($root_folder_path ."messages/".$language_code."/cart_messages.php");

	$vc = get_session("session_vc");
	$order_id = get_session("session_order_id");

	$order_errors = check_order($order_id, $vc);
	if($order_errors) {
		echo $order_errors;
		exit;
	}
	$payment_params = payment_params($order_id);
	if(!is_array($payment_params)){
		$error_message = 'Payment parameters not send!';
		set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}

	$variables = payment_variables($order_id);
	$xml  = '<?xml version="1.0" encoding="utf-8"?>'; //<?
	$xml .= '<checkout-shopping-cart xmlns="http://checkout.google.com/schema/2">';
	$xml .= '	<shopping-cart>';
	$xml .= '		<items>';
	foreach ($variables["items"] as $number => $item) {
		$xml .= '			<item>';
		$xml .= '				<item-name>'.$payment_params['item-name'].' '.$item['item_text'].'</item-name>';
		$xml .= '				<item-description> Price:'.$item['price'].' Qty:'.$item['quantity'].' Tax:'.$item['total_tax'].'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">'.$item['total_price_with_tax'].'</unit-price>';
		$xml .= '				<quantity>1</quantity>';
		$xml .= '			</item>';
	}
	if ($variables["total_discount_with_tax_cr"] != 0) {
		$xml .= '			<item>';
		$xml .= '				<item-name>'.TOTAL_DISCOUNT_MSG.'</item-name>';
		$xml .= '				<item-description>'.TOTAL_DISCOUNT_MSG.'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">-'.$variables["total_discount_with_tax_cr"].'</unit-price>';
		$xml .= '				<quantity>1</quantity>';
		$xml .= '			</item>';
	}
	if ($variables["processing_fee"] != 0) {
		echo '<b>'.PROCESSING_FEE_MSG.'</b> cost:'.$variables["processing_fee_cr"].'<hr>';
		$xml .= '			<item>';
		$xml .= '				<item-name>'.PROCESSING_FEE_MSG.'</item-name>';
		$xml .= '				<item-description>'.PROCESSING_FEE_MSG.'</item-description>';
		$xml .= '				<unit-price currency="'.$payment_params['currency'].'">'.$variables["processing_fee_cr"].'</unit-price>';
		$xml .= '				<quantity>1</quantity>';
		$xml .= '			</item>';
	}
	$xml .= '		</items>';
	$xml .= '		<merchant-private-data>';
	$xml .= '			<merchant-note>'.$order_id.'</merchant-note>';
	$xml .= '		</merchant-private-data>';
	$xml .= '	</shopping-cart>';
	$xml .= '	<checkout-flow-support>';
	$xml .= '		<merchant-checkout-flow-support>';
	if ($variables["shipping_type_desc"]) {
		$xml .= '			<shipping-methods>';
		$xml .= '				<flat-rate-shipping name="'.$variables["shipping_type_desc"].'">';
		$xml .= '					<price currency="'.$payment_params['currency'].'">'.$variables["shipping_cost_with_tax_cr"].'</price>';
		$xml .= '				</flat-rate-shipping>';
		$xml .= '			</shipping-methods>';
	}
	$xml .= '		</merchant-checkout-flow-support>';
	$xml .= '	</checkout-flow-support>';
	$xml .= '</checkout-shopping-cart>';

	$cart = urlencode(base64_encode($xml));
	$signature = urlencode(base64_encode(CalcHmacSha1($xml)));
	
	$params='cart='.$cart.'&signature='.$signature;

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $payment_params['action_url']);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_HEADER, 1);
	curl_setopt($ch, CURLOPT_TIMEOUT, 90);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
	curl_setopt($ch, CURLOPT_NOBODY, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_ENCODING, "x-www-form-urlencoded");
	$result=curl_exec ($ch);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if (curl_errno($ch)){
		$error_message = curl_errno($ch)." - ".curl_error($ch);
		set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}
	curl_close ($ch);
	$resp = explode("\n", $result);
	if(!is_array($resp)){
		$error_message = 'Google does not answer!';
		set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}
	$href = explode(": ", $resp[1]);
	if(!is_array($href)){
		$error_message = 'Google does not answer!';
		set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}
	if(!isset($href[1])){
		$error_message = 'Google does not answer!';
		set_error($order_id, $error_message);
		echo $error_message;
		exit;
	}
	header("Location: $href[1]");
	exit;

?>